SystemOrganization addCategory: #'Versionner-Spec-Browser'!

ComposableModel subclass: #AddConfigurationForm
	instanceVariableNames: 'configurationName allPackages nameLabel packagesLabel repositoryLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Spec-Browser'!

!AddConfigurationForm class methodsFor: 'nil' stamp: 'JuanPabloSandovalA 6/8/2012 15:50'!
internSpec
	""
	^ { #ComposableSpec.
				"configurationName"
				#add:. {{#model. #nameLabel. #internSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 0@0). (5@0 corner: 150@20)}}.
				#add:. {{#model. #configurationName. #internSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 1@0.1). (150@0 corner: 1@20)}}.
				"packages"
				#add:. {{#model. #packagesLabel. #internSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0.1 corner: 1@0.8). (5@5 corner: 150@0)}}.
				#add:. {{#model. #allPackages. #internSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0.1 corner: 1@0.8). (150@0 corner: 1@200)}}.
				"repositories"
				#add:. {{#model. #repositoryLabel. #internSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0.9 corner: 1@1). (0@0 corner: 150@0)}}.
				#add:. {{#model. #allRepositories. #internSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0.9 corner: 1@1). (150@0 corner: 1@0)}}.
				}.! !

!AddConfigurationForm methodsFor: 'nil' stamp: 'JuanPabloSandovalA 6/8/2012 14:58'!
allPackages
	allPackages ifNil:[
		allPackages := self instantiate: ListComposableModel.
		].
	
	^ allPackages.! !

!AddConfigurationForm methodsFor: 'nil' stamp: 'JuanPabloSandovalA 6/8/2012 15:33'!
allRepositories
	allRepositories ifNil:[
		allRepositories := self instantiate: DropListModel.
		allRepositories items: (#('1' '2' '3') collect:[:number|  DropListItem named: number do:[ ]]).
		].
	
	^ allRepositories.
	! !

!AddConfigurationForm methodsFor: 'nil' stamp: 'JuanPabloSandovalA 6/8/2012 14:54'!
configurationName
	
	configurationName ifNil:[
		configurationName := self instantiate: TextModel. ].
	
	^ configurationName.! !

!AddConfigurationForm methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/8/2012 15:51'!
initialExtent
	^  (200@200).
	! !

!AddConfigurationForm methodsFor: 'nil' stamp: 'JuanPabloSandovalA 6/8/2012 15:06'!
nameLabel
	nameLabel ifNil:[
		nameLabel := self instantiate: LabelModel.
		nameLabel text:'Configuration Name:'.
		].
	
	^ nameLabel.! !

!AddConfigurationForm methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/8/2012 15:12'!
packagesLabel
	
	packagesLabel ifNil:[
		packagesLabel := self instantiate: LabelModel.
		packagesLabel text: 'Packages:'.	
		].
	
	^ packagesLabel.
	! !

!AddConfigurationForm methodsFor: 'nil' stamp: 'JuanPabloSandovalA 6/8/2012 15:40'!
repositoryLabel

	repositoryLabel ifNil:[
		repositoryLabel := self instantiate: LabelModel.
		repositoryLabel text: 'Repository:'.	
		].
	
	^ repositoryLabel.
	
	! !

!AddConfigurationForm methodsFor: 'nil' stamp: 'JuanPabloSandovalA 6/8/2012 15:08'!
title
	^ 'Add Configuration'.! !

ComposableModel subclass: #VersionnerSpecBrowser
	instanceVariableNames: 'configurations versions toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Spec-Browser'!

!VersionnerSpecBrowser class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/7/2012 15:40'!
internSpec
	""
	^ { #ComposableSpec.
				"basic commands"
				#add:. {{#model. #toolbar. #internSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 1@0). (0@0 corner: 0@25)}}.
				"configurations"
				#add:. {{#model. #configurations. #internSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 0.5@1). (0@25 corner: 0@0)}}.
				"versions"
				#add:. {{#model. #versions. #internSpec.}. 
				#layout:.  {#FrameLayout.
				#fractions:offsets:. (0.5@0 corner: 1@1).  (0@25 corner: 0@0)}}}.! !

!VersionnerSpecBrowser class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/4/2012 12:41'!
open
	^ self openOn: (MBConfigurationRoot current configurations).! !

!VersionnerSpecBrowser class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/4/2012 12:43'!
openOn: configurations
	| browser |
	browser := self new. 
	browser configurations: configurations.
	browser openWithSpec.
	^ browser.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 15:56'!
buildMenuForConfiguration: aMenu

	aMenu title: 'Versions'.
	aMenu target: self.		
	MBConfigurationInfoCommand allSubclasses do:[ :cmd |
		[aMenu add: (cmd new title) target: [ 
			self configurations selectedItem ifNotNil:[:item |
			(cmd target: item for: self ) execute.
			self refresh. ]. ] selector: #value ] on: Error do:["none"]].
	aMenu addLine.
	
	^ aMenu.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 15:57'!
buildMenuForVersions: aMenu

	aMenu title: 'Versions'.
	aMenu target: self.
	
	self versionCommands do:[ :cmd |
		[aMenu add: (cmd new title) target: [ 
			self versions selectedItem ifNotNil:[:item |
			(cmd target: item for: self ) execute.
			self refresh. ]. ] selector: #value ] on: Error do:["none"]].
	aMenu addLine.
	
	^ aMenu.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 15:00'!
configurations
	"lazy"
	configurations ifNil:[
			configurations := self instantiate: IconListModel. 
			configurations icons: [:configuration | self iconForConfiguration: configuration ]. 
			configurations menu: [:aMenu | self buildMenuForConfiguration: aMenu ].
			configurations wrappingBlock: [:item | item asStringMorph ].
			configurations whenSelectedItemChanges: [:selection | 
				selection ifNotNil:[ self versions: (selection versions). ].
			 ].
		].
	
	^ configurations.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/4/2012 12:22'!
configurations: aList
	"Here I reroute my entry point to the list model's entry point"
	self configurations items: aList.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 14:53'!
iconForConfiguration: aConfiguration

	"should return an IconMorph"
	^ (aConfiguration isDirty)
					ifTrue:  [ VersionnerGLMIcons configurationChangedIcon] 
					ifFalse: [ VersionnerGLMIcons configurationIcon              ].! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 14:53'!
iconForVersion: aVersion

	"should return an IconMorph"
	^ VersionnerGLMIcons versionIcon.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 16:11'!
initialize 
	super initialize.
	self register.! !

!VersionnerSpecBrowser methodsFor: 'actions' stamp: 'JuanPabloSandovalA 6/7/2012 16:11'!
refresh
	"refresh list of configurations and versions"
	configurations updateList.
	versions updateList.! !

!VersionnerSpecBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/7/2012 16:11'!
register
	"Set up dependencies"
	
	MBConfigurationRoot current announcer
		on: MBConfigurationInfoCreated send: #refresh to: self;
		on: MBConfigurationInfoChanged send: #refresh to: self;
		on: MBConfigurationInfoDeleted send: #refresh to: self;
		on: MBInfoListChanged send: #refresh to: self.
! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/4/2012 12:44'!
title
	^ 'Versionner'! !

!VersionnerSpecBrowser methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/7/2012 16:01'!
toolbar
	toolbar ifNil:[
		toolbar := self instantiate: VersionnerToolBar.
		toolbar browser: self.
		].
	^ toolbar.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 14:47'!
versionCommands
	|commands|
	commands := OrderedCollection new.
	commands add:MBAddDescriptionCommand.
	commands add:MBCompareToCurrentVersionCommand.
	commands add:MBCompareToStableVersionCommand.
	commands add:MBOpenForDevelopmentCommand.
	commands add:MBReleaseDevelopmentVersionCommand.
	commands add:MBSetDescriptionCommand.
	commands add:MBUpdatePackageCommand. 
	commands add:MBUpdateProjectCommand.
	^ commands.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 14:46'!
versions
	"lazy"
	versions ifNil:[
			versions := self instantiate: IconListModel. 
			versions whenSelectedItemChanges: [:selection |  selection ifNil: [  ] ifNotNil: [:m |   ]].
			versions menu: [:aMenu | self buildMenuForVersions: aMenu ].
			versions icons: [:version | self iconForVersion: version ]. 
			].
	^ versions.! !

!VersionnerSpecBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/4/2012 12:22'!
versions: aList
	"Here I reroute my entry point to the list model's entry point"
	self versions items: aList.! !

ComposableModel subclass: #VersionnerToolBar
	instanceVariableNames: 'new commit update load browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Spec-Browser'!

!VersionnerToolBar class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/7/2012 15:36'!
internSpec
	<spec>
	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#new.	#internSpec}.
			#addMorph:. {#model.	#commit.	#internSpec}.
			#addMorph:. {#model.	#update.	#internSpec}.
			#addMorph:. {#model.	#load.	#internSpec}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#shrinkWrap.	}! !

!VersionnerToolBar class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/7/2012 15:36'!
title
	^ 'Versionner ToolBar'! !

!VersionnerToolBar methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/7/2012 15:59'!
browser
	^ browser.! !

!VersionnerToolBar methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/7/2012 15:59'!
browser: aSpecBrowser
	browser := aSpecBrowser.! !

!VersionnerToolBar methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 16:06'!
commit
	commit ifNil:[
		commit := self instantiate: ButtonModel.
		commit label: 'Commit'.
		commit action:[
			self execute: MBSaveAllPackagesAndAddVersionCommand with:(browser configurations selectedItem).].
		
		].
	^ commit.
! !

!VersionnerToolBar methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/7/2012 16:10'!
execute: aCommandClass with: entity
	""
	(aCommandClass target: entity for: self) execute.
	
	browser refresh.! !

!VersionnerToolBar methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 16:06'!
load
	load ifNil:[
		load := self instantiate: ButtonModel.
		load label: 'Load'.
		load action:[ self execute: MBLoadProjectCommand with:self.].
		].
	^ load.! !

!VersionnerToolBar methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 16:04'!
new
	new ifNil:[
		new := self instantiate: ButtonModel.
		new label: '+ Configuration'.
		new action: [ self execute: MBAddConfigurationCommand with:self.
			      	self refresh.].
		].
	^ new.! !

!VersionnerToolBar methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/7/2012 16:05'!
update
	update ifNil:[
		update := self instantiate: ButtonModel.
		update label: 'Update'.
		update action:[
				self execute: MBUpdateFromItsRepositoryCommand with:(browser configurations selectedItem).           ].
		
		].
	^ update.! !
